using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using HySoft.DBUtility;

namespace HySoft.BaseCallCenter.DAL
{
    /// <summary>
    /// 数据访问类:T_Ask_QuestionCategory
    /// </summary>
    public partial class T_Ask_QuestionCategory
    {
        public T_Ask_QuestionCategory()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_CategoryId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Ask_QuestionCategory");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
			};
            parameters[0].Value = F_CategoryId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(HySoft.BaseCallCenter.Model.T_Ask_QuestionCategory model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Ask_QuestionCategory(");
            strSql.Append("F_CategoryNumber,F_CategoryName,F_CategoryEName,F_Layer,F_ParentId,F_CategoryType,F_CanDelete,F_IsCommon,F_Sort,F_Expand1,F_Expand2,F_CreateOn,F_CreateBy,F_DeleteFlag)");
            strSql.Append(" values (");
            strSql.Append("@F_CategoryNumber,@F_CategoryName,@F_CategoryEName,@F_Layer,@F_ParentId,@F_CategoryType,@F_CanDelete,@F_IsCommon,@F_Sort,@F_Expand1,@F_Expand2,@F_CreateOn,@F_CreateBy,@F_DeleteFlag)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
					new SqlParameter("@F_CategoryNumber", SqlDbType.NVarChar,200),
					new SqlParameter("@F_CategoryName", SqlDbType.NVarChar,50),
					new SqlParameter("@F_CategoryEName", SqlDbType.NVarChar,200),
					new SqlParameter("@F_Layer", SqlDbType.Int,4),
					new SqlParameter("@F_ParentId", SqlDbType.Int,4),
					new SqlParameter("@F_CategoryType", SqlDbType.SmallInt,2),
					new SqlParameter("@F_CanDelete", SqlDbType.SmallInt,2),
					new SqlParameter("@F_IsCommon", SqlDbType.SmallInt,2),
					new SqlParameter("@F_Sort", SqlDbType.Int,4),
					new SqlParameter("@F_Expand1", SqlDbType.NVarChar,50),
					new SqlParameter("@F_Expand2", SqlDbType.NVarChar,50),
					new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
					new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
					new SqlParameter("@F_DeleteFlag", SqlDbType.SmallInt,2)};
            parameters[0].Value = model.F_CategoryNumber;
            parameters[1].Value = model.F_CategoryName;
            parameters[2].Value = model.F_CategoryEName;
            parameters[3].Value = model.F_Layer;
            parameters[4].Value = model.F_ParentId;
            parameters[5].Value = model.F_CategoryType;
            parameters[6].Value = model.F_CanDelete;
            parameters[7].Value = model.F_IsCommon;
            parameters[8].Value = model.F_Sort;
            parameters[9].Value = model.F_Expand1;
            parameters[10].Value = model.F_Expand2;
            parameters[11].Value = model.F_CreateOn;
            parameters[12].Value = model.F_CreateBy;
            parameters[13].Value = model.F_DeleteFlag;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(HySoft.BaseCallCenter.Model.T_Ask_QuestionCategory model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Ask_QuestionCategory set ");
            strSql.Append("F_CategoryNumber=@F_CategoryNumber,");
            strSql.Append("F_CategoryName=@F_CategoryName,");
            strSql.Append("F_CategoryEName=@F_CategoryEName,");
            strSql.Append("F_Layer=@F_Layer,");
            strSql.Append("F_ParentId=@F_ParentId,");
            strSql.Append("F_CategoryType=@F_CategoryType,");
            strSql.Append("F_CanDelete=@F_CanDelete,");
            strSql.Append("F_IsCommon=@F_IsCommon,");
            strSql.Append("F_Sort=@F_Sort,");
            strSql.Append("F_Expand1=@F_Expand1,");
            strSql.Append("F_Expand2=@F_Expand2,");
            strSql.Append("F_CreateOn=@F_CreateOn,");
            strSql.Append("F_CreateBy=@F_CreateBy,");
            strSql.Append("F_DeleteFlag=@F_DeleteFlag");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_CategoryNumber", SqlDbType.NVarChar,200),
					new SqlParameter("@F_CategoryName", SqlDbType.NVarChar,50),
					new SqlParameter("@F_CategoryEName", SqlDbType.NVarChar,200),
					new SqlParameter("@F_Layer", SqlDbType.Int,4),
					new SqlParameter("@F_ParentId", SqlDbType.Int,4),
					new SqlParameter("@F_CategoryType", SqlDbType.SmallInt,2),
					new SqlParameter("@F_CanDelete", SqlDbType.SmallInt,2),
					new SqlParameter("@F_IsCommon", SqlDbType.SmallInt,2),
					new SqlParameter("@F_Sort", SqlDbType.Int,4),
					new SqlParameter("@F_Expand1", SqlDbType.NVarChar,50),
					new SqlParameter("@F_Expand2", SqlDbType.NVarChar,50),
					new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
					new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
					new SqlParameter("@F_DeleteFlag", SqlDbType.SmallInt,2),
					new SqlParameter("@F_CategoryId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CategoryNumber;
            parameters[1].Value = model.F_CategoryName;
            parameters[2].Value = model.F_CategoryEName;
            parameters[3].Value = model.F_Layer;
            parameters[4].Value = model.F_ParentId;
            parameters[5].Value = model.F_CategoryType;
            parameters[6].Value = model.F_CanDelete;
            parameters[7].Value = model.F_IsCommon;
            parameters[8].Value = model.F_Sort;
            parameters[9].Value = model.F_Expand1;
            parameters[10].Value = model.F_Expand2;
            parameters[11].Value = model.F_CreateOn;
            parameters[12].Value = model.F_CreateBy;
            parameters[13].Value = model.F_DeleteFlag;
            parameters[14].Value = model.F_CategoryId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_CategoryId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Ask_QuestionCategory ");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
			};
            parameters[0].Value = F_CategoryId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_CategoryIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Ask_QuestionCategory ");
            strSql.Append(" where F_CategoryId in (" + F_CategoryIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public HySoft.BaseCallCenter.Model.T_Ask_QuestionCategory GetModel(int F_CategoryId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_CategoryId,F_CategoryNumber,F_CategoryName,F_CategoryEName,F_Layer,F_ParentId,F_CategoryType,F_CanDelete,F_IsCommon,F_Sort,F_Expand1,F_Expand2,F_CreateOn,F_CreateBy,F_DeleteFlag from T_Ask_QuestionCategory ");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
			};
            parameters[0].Value = F_CategoryId;

            HySoft.BaseCallCenter.Model.T_Ask_QuestionCategory model = new HySoft.BaseCallCenter.Model.T_Ask_QuestionCategory();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["F_CategoryId"] != null && ds.Tables[0].Rows[0]["F_CategoryId"].ToString() != "")
                {
                    model.F_CategoryId = int.Parse(ds.Tables[0].Rows[0]["F_CategoryId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CategoryNumber"] != null && ds.Tables[0].Rows[0]["F_CategoryNumber"].ToString() != "")
                {
                    model.F_CategoryNumber = ds.Tables[0].Rows[0]["F_CategoryNumber"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_CategoryName"] != null && ds.Tables[0].Rows[0]["F_CategoryName"].ToString() != "")
                {
                    model.F_CategoryName = ds.Tables[0].Rows[0]["F_CategoryName"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_CategoryEName"] != null && ds.Tables[0].Rows[0]["F_CategoryEName"].ToString() != "")
                {
                    model.F_CategoryEName = ds.Tables[0].Rows[0]["F_CategoryEName"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_Layer"] != null && ds.Tables[0].Rows[0]["F_Layer"].ToString() != "")
                {
                    model.F_Layer = int.Parse(ds.Tables[0].Rows[0]["F_Layer"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_ParentId"] != null && ds.Tables[0].Rows[0]["F_ParentId"].ToString() != "")
                {
                    model.F_ParentId = int.Parse(ds.Tables[0].Rows[0]["F_ParentId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CategoryType"] != null && ds.Tables[0].Rows[0]["F_CategoryType"].ToString() != "")
                {
                    model.F_CategoryType = int.Parse(ds.Tables[0].Rows[0]["F_CategoryType"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CanDelete"] != null && ds.Tables[0].Rows[0]["F_CanDelete"].ToString() != "")
                {
                    model.F_CanDelete = int.Parse(ds.Tables[0].Rows[0]["F_CanDelete"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_IsCommon"] != null && ds.Tables[0].Rows[0]["F_IsCommon"].ToString() != "")
                {
                    model.F_IsCommon = int.Parse(ds.Tables[0].Rows[0]["F_IsCommon"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Sort"] != null && ds.Tables[0].Rows[0]["F_Sort"].ToString() != "")
                {
                    model.F_Sort = int.Parse(ds.Tables[0].Rows[0]["F_Sort"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Expand1"] != null && ds.Tables[0].Rows[0]["F_Expand1"].ToString() != "")
                {
                    model.F_Expand1 = ds.Tables[0].Rows[0]["F_Expand1"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_Expand2"] != null && ds.Tables[0].Rows[0]["F_Expand2"].ToString() != "")
                {
                    model.F_Expand2 = ds.Tables[0].Rows[0]["F_Expand2"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_CreateOn"] != null && ds.Tables[0].Rows[0]["F_CreateOn"].ToString() != "")
                {
                    model.F_CreateOn = DateTime.Parse(ds.Tables[0].Rows[0]["F_CreateOn"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CreateBy"] != null && ds.Tables[0].Rows[0]["F_CreateBy"].ToString() != "")
                {
                    model.F_CreateBy = int.Parse(ds.Tables[0].Rows[0]["F_CreateBy"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_DeleteFlag"] != null && ds.Tables[0].Rows[0]["F_DeleteFlag"].ToString() != "")
                {
                    model.F_DeleteFlag = int.Parse(ds.Tables[0].Rows[0]["F_DeleteFlag"].ToString());
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_CategoryId,F_CategoryNumber,F_CategoryName,F_CategoryEName,F_Layer,F_ParentId,F_CategoryType,F_CanDelete,F_IsCommon,F_Sort,F_Expand1,F_Expand2,F_CreateOn,F_CreateBy,F_DeleteFlag ");
            strSql.Append(" FROM T_Ask_QuestionCategory ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_CategoryId,F_CategoryNumber,F_CategoryName,F_CategoryEName,F_Layer,F_ParentId,F_CategoryType,F_CanDelete,F_IsCommon,F_Sort,F_Expand1,F_Expand2,F_CreateOn,F_CreateBy,F_DeleteFlag ");
            strSql.Append(" FROM T_Ask_QuestionCategory ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Ask_QuestionCategory ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_CategoryId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Ask_QuestionCategory T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  Method
    }
}

